Index: src/xend_internal.c
===================================================================
RCS file: /data/cvs/libvirt/src/xend_internal.c,v
retrieving revision 1.105
diff -u -r1.105 xend_internal.c
--- src/xend_internal.c	23 Mar 2007 16:15:07 -0000	1.105
+++ src/xend_internal.c	4 Apr 2007 10:14:39 -0000
@@ -34,6 +34,7 @@
 #include "internal.h"
 #include "sexpr.h"
 #include "xml.h"
+#include "xen_unified.h"
 #include "xend_internal.h"
 #include "xen_internal.h" /* for DOM0_INTERFACE_VERSION */
 #include "xs_internal.h" /* To extract VNC port & Serial console TTY */
@@ -60,8 +61,8 @@
 #endif /* PROXY */
 
 #ifndef PROXY
-static virDriver xenDaemonDriver = {
-    VIR_DRV_XEN_DAEMON,
+virDriver xenDaemonDriver = {
+    -1,
     "XenDaemon",
     (DOM0_INTERFACE_VERSION >> 24) * 1000000 +
     ((DOM0_INTERFACE_VERSION >> 16) & 0xFF) * 1000 +
@@ -109,13 +110,14 @@
 };
 
 /**
- * xenDaemonRegister:
+ * xenDaemonInit:
  *
- * Registers the xenDaemon driver
+ * Initialise the xenDaemon driver.
  */
-void xenDaemonRegister(void)
+int
+xenDaemonInit (void)
 {
-    virRegisterDriver(&xenDaemonDriver);
+    return 0;
 }
 #endif /* !PROXY */
 
@@ -210,8 +212,9 @@
     int s;
     int serrno;
     int no_slow_start = 1;
+    xenUnifiedPrivatePtr priv = (xenUnifiedPrivatePtr) xend->privateData;
 
-    s = socket(xend->type, SOCK_STREAM, 0);
+    s = socket(priv->type, SOCK_STREAM, 0);
     if (s == -1) {
         virXendError(xend, VIR_ERR_INTERNAL_ERROR,
                      "failed to create a socket");
@@ -225,7 +228,7 @@
                sizeof(no_slow_start));
 
 
-    if (connect(s, xend->addr, xend->len) == -1) {
+    if (connect(s, priv->addr, priv->len) == -1) {
         serrno = errno;
         close(s);
         errno = serrno;
@@ -830,21 +833,22 @@
 xenDaemonOpen_unix(virConnectPtr conn, const char *path)
 {
     struct sockaddr_un *addr;
+    xenUnifiedPrivatePtr priv = (xenUnifiedPrivatePtr) conn->privateData;
 
     if ((conn == NULL) || (path == NULL))
         return (-1);
 
-    addr = &conn->addr_un;
+    addr = &priv->addr_un;
     addr->sun_family = AF_UNIX;
     memset(addr->sun_path, 0, sizeof(addr->sun_path));
     strncpy(addr->sun_path, path, sizeof(addr->sun_path));
 
-    conn->len = sizeof(addr->sun_family) + strlen(addr->sun_path);
-    if ((unsigned int) conn->len > sizeof(addr->sun_path))
-        conn->len = sizeof(addr->sun_path);
+    priv->len = sizeof(addr->sun_family) + strlen(addr->sun_path);
+    if ((unsigned int) priv->len > sizeof(addr->sun_path))
+        priv->len = sizeof(addr->sun_path);
 
-    conn->addr = (struct sockaddr *) addr;
-    conn->type = PF_UNIX;
+    priv->addr = (struct sockaddr *) addr;
+    priv->type = PF_UNIX;
 
     return (0);
 }
@@ -866,10 +870,13 @@
 {
     struct in_addr ip;
     struct hostent *pent;
+    xenUnifiedPrivatePtr priv;
 
     if ((conn == NULL) || (host == NULL) || (port <= 0))
         return (-1);
 
+    priv = (xenUnifiedPrivatePtr) conn->privateData;
+
     pent = gethostbyname(host);
     if (pent == NULL) {
         if (inet_aton(host, &ip) == 0) {
@@ -881,13 +888,13 @@
         memcpy(&ip, pent->h_addr_list[0], sizeof(ip));
     }
 
-    conn->len = sizeof(struct sockaddr_in);
-    conn->addr = (struct sockaddr *) &conn->addr_in;
-    conn->type = PF_INET;
-
-    conn->addr_in.sin_family = AF_INET;
-    conn->addr_in.sin_port = htons(port);
-    memcpy(&conn->addr_in.sin_addr, &ip, sizeof(ip));
+    priv->len = sizeof(struct sockaddr_in);
+    priv->addr = (struct sockaddr *) &priv->addr_in;
+    priv->type = PF_INET;
+
+    priv->addr_in.sin_family = AF_INET;
+    priv->addr_in.sin_port = htons(port);
+    memcpy(&priv->addr_in.sin_addr, &ip, sizeof(ip));
 
     return (0);
 }
@@ -1121,12 +1128,15 @@
 xend_detect_config_version(virConnectPtr conn) {
     struct sexpr *root;
     const char *value;
+    xenUnifiedPrivatePtr priv;
 
     if (!VIR_IS_CONNECT(conn)) {
         virXendError(conn, VIR_ERR_INVALID_CONN, __FUNCTION__);
         return (-1);
     }
 
+    priv = (xenUnifiedPrivatePtr) conn->privateData;
+
     root = sexpr_get(conn, "/xend/node/");
     if (root == NULL)
         return (-1);
@@ -1134,14 +1144,14 @@
     value = sexpr_node(root, "node/xend_config_format");
     
     if (value) {
-        conn->xendConfigVersion = strtol(value, NULL, 10);
+        priv->xendConfigVersion = strtol(value, NULL, 10);
     }  else {
         /* Xen prior to 3.0.3 did not have the xend_config_format
            field, and is implicitly version 1. */
-        conn->xendConfigVersion = 1;
+        priv->xendConfigVersion = 1;
     }
     sexpr_free(root);
-    return conn->xendConfigVersion;
+    return priv->xendConfigVersion;
 }
 
 /**
@@ -1804,10 +1814,13 @@
     char uuid[VIR_UUID_BUFLEN];
     const char *name;
     const char *tmp;
+    xenUnifiedPrivatePtr priv;
 
     if ((conn == NULL) || (root == NULL))
         return(NULL);
 
+    priv = (xenUnifiedPrivatePtr) conn->privateData;
+
     dst_uuid = (char *) &uuid[0];
     if (sexpr_uuid(&dst_uuid, root, "domain/uuid") == NULL)
         goto error;
@@ -1824,7 +1837,7 @@
     /* New 3.0.4 XenD will not report a domid for inactive domains,
      * so only error out for old XenD
      */
-    if (!tmp && conn->xendConfigVersion < 3)
+    if (!tmp && priv->xendConfigVersion < 3)
         goto error;
 
     if (tmp)
@@ -1873,79 +1886,85 @@
     int ret;
     unsigned long version;
 
-    if ((name == NULL) || (name[0] == 0) || (!strcasecmp(name, "xen"))) {
-	/*
-	 * try first to open the unix socket
-	 */
-	ret = xenDaemonOpen_unix(conn, "/var/lib/xend/xend-socket");
-	if (ret < 0)
-	    goto try_http;
-	ret = xenDaemonGetVersion(conn, &version);
-	if (ret == 0)
-	    goto done;
+    /* If the name is just "xen" (it might originally have been NULL, see
+     * xenUnifiedOpen) then try default paths and methods to get to the
+     * xend socket.
+     */
+    if (strcasecmp (name, "xen") == 0) {
+        /*
+         * try first to open the unix socket
+         */
+        ret = xenDaemonOpen_unix(conn, "/var/lib/xend/xend-socket");
+        if (ret < 0)
+            goto try_http;
+        ret = xenDaemonGetVersion(conn, &version);
+        if (ret == 0)
+            goto done;
 
-try_http:
+    try_http:
         /*
-	 * try though http on port 8000
-	 */
-	ret = xenDaemonOpen_tcp(conn, "localhost", 8000);
-	if (ret < 0)
-	    goto failed;
-	ret = xenDaemonGetVersion(conn, &version);
-	if (ret < 0)
-	    goto failed;
+         * try though http on port 8000
+         */
+        ret = xenDaemonOpen_tcp(conn, "localhost", 8000);
+        if (ret < 0)
+            goto failed;
+        ret = xenDaemonGetVersion(conn, &version);
+        if (ret < 0)
+            goto failed;
     } else {
         /*
-	 * We were given a connection name, expected to be an URL
-	 */
-	uri = xmlParseURI(name);
-	if (uri == NULL) {
-	    if (!(flags & VIR_DRV_OPEN_QUIET))
-		virXendError(conn, VIR_ERR_NO_SUPPORT, name);
-	    goto failed;
-	}
+         * We were given a connection name, expected to be an URL
+         */
+        uri = xmlParseURI(name);
+        if (uri == NULL) {
+            if (!(flags & VIR_DRV_OPEN_QUIET))
+                virXendError(conn, VIR_ERR_NO_SUPPORT, name);
+            goto failed;
+        }
 
-	if (uri->scheme == NULL) {
-	    /* It should be a file access */
-	    if (uri->path == NULL) {
-		if (!(flags & VIR_DRV_OPEN_QUIET))
-		    virXendError(conn, VIR_ERR_NO_SUPPORT, name);
-	        goto failed;
-	    }
-	    ret = xenDaemonOpen_unix(conn, uri->path);
-	    if (ret < 0)
-	        goto failed;
-
-	    ret = xenDaemonGetVersion(conn, &version);
-	    if (ret < 0)
-		goto failed;
-	} else if (!strcasecmp(uri->scheme, "http")) {
-	    ret = xenDaemonOpen_tcp(conn, uri->server, uri->port);
+        if (uri->scheme == NULL) {
+            /* It should be a file access */
+            if (uri->path == NULL) {
+                if (!(flags & VIR_DRV_OPEN_QUIET))
+                    virXendError(conn, VIR_ERR_NO_SUPPORT, name);
+                goto failed;
+            }
+            ret = xenDaemonOpen_unix(conn, uri->path);
             if (ret < 0)
-	        goto failed;
-	    ret = xenDaemonGetVersion(conn, &version);
-	    if (ret < 0)
-	        goto failed;
-	} else {
-	    if (!(flags & VIR_DRV_OPEN_QUIET))
-		virXendError(conn, VIR_ERR_NO_SUPPORT, name);
-	    goto failed;
-	}
+                goto failed;
+
+            ret = xenDaemonGetVersion(conn, &version);
+            if (ret < 0)
+                goto failed;
+        } else if (!strcasecmp(uri->scheme, "http")) {
+            ret = xenDaemonOpen_tcp(conn, uri->server, uri->port);
+            if (ret < 0)
+                goto failed;
+            ret = xenDaemonGetVersion(conn, &version);
+            if (ret < 0)
+                goto failed;
+        } else {
+            if (!(flags & VIR_DRV_OPEN_QUIET))
+                virXendError(conn, VIR_ERR_NO_SUPPORT, name);
+            goto failed;
+        }
     }
 
-done:
-    /* The XenD config version is used to determine
+ done: 
+   /* The XenD config version is used to determine
      * which APIs / features to activate. Lookup & cache
      * it now to avoid repeated HTTP calls
      */
     if (xend_detect_config_version(conn) < 0) {
-        virXendError(conn, VIR_ERR_INTERNAL_ERROR, "cannot determine xend config version");
+        virXendError(conn, VIR_ERR_INTERNAL_ERROR,
+                     "cannot determine xend config version");
         goto failed;
     }
 
     if (uri != NULL)
         xmlFreeURI(uri);
     return(ret);
+
 failed:
     if (uri != NULL)
         xmlFreeURI(uri);
@@ -1961,12 +1980,12 @@
  * initialized with xenDaemonOpen is no longer needed
  * to free the associated resources.
  *
- * Returns 0 in case of succes, -1 in case of error
+ * Returns 0 in case of success, -1 in case of error
  */
 int
 xenDaemonClose(virConnectPtr conn ATTRIBUTE_UNUSED)
 {
-    return(0);
+    return 0;
 }
 
 /**
@@ -2177,13 +2196,17 @@
 {
     unsigned long ret = 0;
     struct sexpr *root;
+    xenUnifiedPrivatePtr priv;
 
     if ((domain == NULL) || (domain->conn == NULL) || (domain->name == NULL)) {
         virXendError((domain ? domain->conn : NULL), VIR_ERR_INVALID_ARG,
 	             __FUNCTION__);
         return(-1);
     }
-    if (domain->id < 0 && domain->conn->xendConfigVersion < 3)
+
+    priv = (xenUnifiedPrivatePtr) domain->conn->privateData;
+
+    if (domain->id < 0 && priv->xendConfigVersion < 3)
         return(-1);
 
     /* can we ask for a subset ? worth it ? */
@@ -2213,13 +2236,17 @@
 xenDaemonDomainSetMaxMemory(virDomainPtr domain, unsigned long memory)
 {
     char buf[1024];
+    xenUnifiedPrivatePtr priv;
 
     if ((domain == NULL) || (domain->conn == NULL) || (domain->name == NULL)) {
         virXendError((domain ? domain->conn : NULL), VIR_ERR_INVALID_ARG,
 	             __FUNCTION__);
         return(-1);
     }
-    if (domain->id < 0 && domain->conn->xendConfigVersion < 3)
+
+    priv = (xenUnifiedPrivatePtr) domain->conn->privateData;
+
+    if (domain->id < 0 && priv->xendConfigVersion < 3)
         return(-1);
 
     snprintf(buf, sizeof(buf), "%lu", memory >> 10);
@@ -2247,13 +2274,17 @@
 xenDaemonDomainSetMemory(virDomainPtr domain, unsigned long memory)
 {
     char buf[1024];
+    xenUnifiedPrivatePtr priv;
 
     if ((domain == NULL) || (domain->conn == NULL) || (domain->name == NULL)) {
         virXendError((domain ? domain->conn : NULL), VIR_ERR_INVALID_ARG,
 	             __FUNCTION__);
         return(-1);
     }
-    if (domain->id < 0 && domain->conn->xendConfigVersion < 3)
+
+    priv = (xenUnifiedPrivatePtr) domain->conn->privateData;
+
+    if (domain->id < 0 && priv->xendConfigVersion < 3)
         return(-1);
 
     snprintf(buf, sizeof(buf), "%lu", memory >> 10);
@@ -2271,12 +2302,15 @@
 {
     char *ret = NULL;
     struct sexpr *root;
+    xenUnifiedPrivatePtr priv;
 
     root = sexpr_get(conn, "/xend/domain/%d?detail=1", domid);
     if (root == NULL)
         return (NULL);
 
-    ret = xend_parse_sexp_desc(conn, root, conn->xendConfigVersion);
+    priv = (xenUnifiedPrivatePtr) conn->privateData;
+
+    ret = xend_parse_sexp_desc(conn, root, priv->xendConfigVersion);
     sexpr_free(root);
 
     return (ret);
@@ -2287,12 +2321,15 @@
 {
     char *ret = NULL;
     struct sexpr *root;
+    xenUnifiedPrivatePtr priv;
 
     root = sexpr_get(conn, "/xend/domain/%s?detail=1", name);
     if (root == NULL)
         return (NULL);
 
-    ret = xend_parse_sexp_desc(conn, root, conn->xendConfigVersion);
+    priv = (xenUnifiedPrivatePtr) conn->privateData;
+
+    ret = xend_parse_sexp_desc(conn, root, priv->xendConfigVersion);
     sexpr_free(root);
 
     return (ret);
@@ -2312,12 +2349,16 @@
 char *
 xenDaemonDomainDumpXML(virDomainPtr domain, int flags ATTRIBUTE_UNUSED)
 {
+    xenUnifiedPrivatePtr priv;
+
     if ((domain == NULL) || (domain->conn == NULL) || (domain->name == NULL)) {
         virXendError((domain ? domain->conn : NULL), VIR_ERR_INVALID_ARG,
 	             __FUNCTION__);
         return(NULL);
     }
-    if (domain->id < 0 && domain->conn->xendConfigVersion < 3)
+    priv = (xenUnifiedPrivatePtr) domain->conn->privateData;
+
+    if (domain->id < 0 && priv->xendConfigVersion < 3)
         return(NULL);
     if (domain->id < 0)
         return xenDaemonDomainDumpXMLByName(domain->conn, domain->name);
@@ -2341,6 +2382,7 @@
 {
     struct sexpr *root;
     int ret;
+    xenUnifiedPrivatePtr priv;
 
     if ((domain == NULL) || (domain->conn == NULL) || (domain->name == NULL) ||
         (info == NULL)) {
@@ -2348,7 +2390,10 @@
 	             __FUNCTION__);
         return(-1);
     }
-    if (domain->id < 0 && domain->conn->xendConfigVersion < 3)
+
+    priv = (xenUnifiedPrivatePtr) domain->conn->privateData;
+
+    if (domain->id < 0 && priv->xendConfigVersion < 3)
         return(-1);
 
     root = sexpr_get(domain->conn, "/xend/domain/%s?detail=1", domain->name);
@@ -2625,6 +2670,7 @@
 xenDaemonDomainSetVcpus(virDomainPtr domain, unsigned int vcpus)
 {
     char buf[VIR_UUID_BUFLEN];
+    xenUnifiedPrivatePtr priv;
 
     if ((domain == NULL) || (domain->conn == NULL) || (domain->name == NULL)
      || (vcpus < 1)) {
@@ -2632,7 +2678,10 @@
 	             __FUNCTION__);
         return (-1);
     }
-    if (domain->id < 0 && domain->conn->xendConfigVersion < 3)
+
+    priv = (xenUnifiedPrivatePtr) domain->conn->privateData;
+
+    if (domain->id < 0 && priv->xendConfigVersion < 3)
         return(-1);
 
     snprintf(buf, sizeof(buf), "%d", vcpus);
@@ -2790,8 +2839,10 @@
     virDomainPtr ret;
     char *name = NULL;
     int id = -1;
+    xenUnifiedPrivatePtr priv = (xenUnifiedPrivatePtr) conn->privateData;
+
     /* Old approach for xen <= 3.0.3 */
-    if (conn->xendConfigVersion < 3) {
+    if (priv->xendConfigVersion < 3) {
         char **names, **tmp;
         unsigned char ident[VIR_UUID_BUFLEN];
         names = xenDaemonListDomainsOld(conn);
@@ -2871,6 +2922,7 @@
     char *sexpr;
     char *name = NULL;
     virDomainPtr dom = NULL;
+    xenUnifiedPrivatePtr priv;
 
     if (!VIR_IS_CONNECT(conn)) {
         virXendError(conn, VIR_ERR_INVALID_CONN, __FUNCTION__);
@@ -2881,7 +2933,9 @@
         return (NULL);
     }
 
-    sexpr = virDomainParseXMLDesc(conn, xmlDesc, &name, conn->xendConfigVersion);
+    priv = (xenUnifiedPrivatePtr) conn->privateData;
+
+    sexpr = virDomainParseXMLDesc(conn, xmlDesc, &name, priv->xendConfigVersion);
     if ((sexpr == NULL) || (name == NULL)) {
         virXendError(conn, VIR_ERR_XML_ERROR, "domain");
         if (sexpr != NULL)
@@ -2939,6 +2993,7 @@
 {
     char *sexpr, *conf;
     int hvm = 0, ret;
+    xenUnifiedPrivatePtr priv;
 
     if ((domain == NULL) || (domain->conn == NULL) || (domain->name == NULL)) {
         virXendError((domain ? domain->conn : NULL), VIR_ERR_INVALID_ARG,
@@ -2946,9 +3001,11 @@
         return (-1);
     }
 
+    priv = (xenUnifiedPrivatePtr) domain->conn->privateData;
+
     if (strcmp(virDomainGetOSType(domain), "linux"))
         hvm = 1;
-    sexpr = virParseXMLDevice(domain->conn, xml, hvm, domain->conn->xendConfigVersion);
+    sexpr = virParseXMLDevice(domain->conn, xml, hvm, priv->xendConfigVersion);
     if (sexpr == NULL)
         return (-1);
     if (!memcmp(sexpr, "(device ", 8)) {
@@ -2993,6 +3050,7 @@
     char *sexpr;
     char *name = NULL;
     virDomainPtr dom;
+    xenUnifiedPrivatePtr priv;
 
     if (!VIR_IS_CONNECT(conn)) {
         virXendError(conn, VIR_ERR_INVALID_CONN, __FUNCTION__);
@@ -3002,10 +3060,13 @@
         virXendError(conn, VIR_ERR_INVALID_ARG, __FUNCTION__);
         return (NULL);
     }
-    if (conn->xendConfigVersion < 3)
+
+    priv = (xenUnifiedPrivatePtr) conn->privateData;
+
+    if (priv->xendConfigVersion < 3)
         return(NULL);
 
-    sexpr = virDomainParseXMLDesc(conn, xmlDesc, &name, conn->xendConfigVersion);
+    sexpr = virDomainParseXMLDesc(conn, xmlDesc, &name, priv->xendConfigVersion);
     if ((sexpr == NULL) || (name == NULL)) {
         virXendError(conn, VIR_ERR_XML_ERROR, "domain");
         if (sexpr != NULL)
@@ -3034,25 +3095,37 @@
         free(name);
     return (NULL);
 }
-int xenDaemonDomainCreate(virDomainPtr domain) {
+int xenDaemonDomainCreate(virDomainPtr domain)
+{
+    xenUnifiedPrivatePtr priv;
+
     if ((domain == NULL) || (domain->conn == NULL) || (domain->name == NULL)) {
         virXendError((domain ? domain->conn : NULL), VIR_ERR_INVALID_ARG,
 	             __FUNCTION__);
         return(-1);
     }
-    if (domain->conn->xendConfigVersion < 3)
+
+    priv = (xenUnifiedPrivatePtr) domain->conn->privateData;
+
+    if (priv->xendConfigVersion < 3)
         return(-1);
 
     return xend_op(domain->conn, domain->name, "op", "start", NULL);
 }
 
-int xenDaemonDomainUndefine(virDomainPtr domain) {
+int xenDaemonDomainUndefine(virDomainPtr domain)
+{
+    xenUnifiedPrivatePtr priv;
+
     if ((domain == NULL) || (domain->conn == NULL) || (domain->name == NULL)) {
         virXendError((domain ? domain->conn : NULL), VIR_ERR_INVALID_ARG,
 	             __FUNCTION__);
         return(-1);
     }
-    if (domain->conn->xendConfigVersion < 3)
+
+    priv = (xenUnifiedPrivatePtr) domain->conn->privateData;
+
+    if (priv->xendConfigVersion < 3)
         return(-1);
 
     return xend_op(domain->conn, domain->name, "op", "delete", NULL);
@@ -3072,8 +3145,9 @@
     struct sexpr *root = NULL;
     int ret = -1;
     struct sexpr *_for_i, *node;
+    xenUnifiedPrivatePtr priv = (xenUnifiedPrivatePtr) conn->privateData;
 
-    if (conn->xendConfigVersion < 3)
+    if (priv->xendConfigVersion < 3)
         return(-1);
 
     root = sexpr_get(conn, "/xend/domain?state=halted");
@@ -3099,8 +3173,9 @@
     struct sexpr *root = NULL;
     int ret = -1;
     struct sexpr *_for_i, *node;
+    xenUnifiedPrivatePtr priv = (xenUnifiedPrivatePtr) conn->privateData;
 
-    if (conn->xendConfigVersion < 3)
+    if (priv->xendConfigVersion < 3)
         return(-1);
 
     if ((names == NULL) || (maxnames <= 0))
Index: src/xend_internal.h
===================================================================
RCS file: /data/cvs/libvirt/src/xend_internal.h,v
retrieving revision 1.29
diff -u -r1.29 xend_internal.h
--- src/xend_internal.h	8 Feb 2007 19:10:25 -0000	1.29
+++ src/xend_internal.h	4 Apr 2007 10:14:39 -0000
@@ -177,8 +177,10 @@
 
   char *xend_parse_domain_sexp(virConnectPtr conn,  char *root, int xendConfigVersion);
 
+extern virDriver xenDaemonDriver;
+int xenDaemonInit (void);
+
 /* refactored ones */
-void xenDaemonRegister(void);
 int xenDaemonOpen(virConnectPtr conn, const char *name, int flags);
 int xenDaemonClose(virConnectPtr conn);
 int xenDaemonGetVersion(virConnectPtr conn, unsigned long *hvVer);
Index: src/xm_internal.c
===================================================================
RCS file: /data/cvs/libvirt/src/xm_internal.c,v
retrieving revision 1.22
diff -u -r1.22 xm_internal.c
--- src/xm_internal.c	22 Mar 2007 18:30:58 -0000	1.22
+++ src/xm_internal.c	4 Apr 2007 10:14:41 -0000
@@ -36,6 +36,7 @@
 #include <libxml/xpath.h>
 
 
+#include "xen_unified.h"
 #include "xm_internal.h"
 #include "xend_internal.h"
 #include "conf.h"
@@ -66,8 +67,8 @@
 #define XEND_PCI_CONFIG_PREFIX "xend-pci-"
 #define QEMU_IF_SCRIPT "qemu-ifup"
 
-static virDriver xenXMDriver = {
-    VIR_DRV_XEN_XM,
+virDriver xenXMDriver = {
+    -1,
     "XenXM",
     (DOM0_INTERFACE_VERSION >> 24) * 1000000 +
     ((DOM0_INTERFACE_VERSION >> 16) & 0xFF) * 1000 +
@@ -127,11 +128,11 @@
                     errmsg, info, NULL, 0, 0, errmsg, info);
 }
 
-void xenXMRegister(void)
+int
+xenXMInit (void)
 {
     char *envConfigDir;
     int safeMode = 0;
-    virRegisterDriver(&xenXMDriver);
 
     /* Disable use of env variable if running setuid */
     if ((geteuid() != getuid()) ||
@@ -145,6 +146,8 @@
     } else {
         strcpy(configDir, XM_CONFIG_DIR);
     }
+
+    return 0;
 }
 
 
@@ -472,12 +475,10 @@
  * We only support a single directory, so repeated calls
  * to open all end up using the same cache of files
  */
-int xenXMOpen(virConnectPtr conn ATTRIBUTE_UNUSED, const char *name, int flags ATTRIBUTE_UNUSED) {
-    if (name &&
-        strcasecmp(name, "xen")) {
-        return (-1);
-    }
-
+int
+xenXMOpen (virConnectPtr conn ATTRIBUTE_UNUSED,
+           const char *name ATTRIBUTE_UNUSED, int flags ATTRIBUTE_UNUSED)
+{
     if (nconnections == 0) {
         configCache = virHashCreate(50);
         if (!configCache)
@@ -584,6 +585,7 @@
     const char *vnclisten = NULL;
     const char *vncpasswd = NULL;
     const char *keymap = NULL;
+    xenUnifiedPrivatePtr priv = (xenUnifiedPrivatePtr) conn->privateData;
 
     if (xenXMConfigGetString(conf, "name", &name) < 0)
         return (NULL);
@@ -798,7 +800,7 @@
         }
     }
 
-    if (hvm && conn->xendConfigVersion == 1) {
+    if (hvm && priv->xendConfigVersion == 1) {
         if (xenXMConfigGetString(conf, "cdrom", &str) == 0) {
             virBufferAdd(buf, "    <disk type='file' device='cdrom'>\n", -1);
             virBufferAdd(buf, "      <driver name='file'/>\n", -1);
@@ -884,7 +886,7 @@
     }
 
     /* HVM guests, or old PV guests use this config format */
-    if (hvm || conn->xendConfigVersion < 3) {
+    if (hvm || priv->xendConfigVersion < 3) {
         if (xenXMConfigGetInt(conf, "vnc", &val) == 0 && val) {
             vnc = 1;
             if (xenXMConfigGetInt(conf, "vncunused", &vncunused) < 0)
@@ -1282,6 +1284,7 @@
     char *sexpr;
     int ret;
     unsigned char uuid[VIR_UUID_BUFLEN];
+    xenUnifiedPrivatePtr priv;
 
     if ((domain == NULL) || (domain->conn == NULL) || (domain->name == NULL)) {
         xenXMError((domain ? domain->conn : NULL), VIR_ERR_INVALID_ARG,
@@ -1297,7 +1300,9 @@
     if (!(xml = xenXMDomainDumpXML(domain, 0)))
         return (-1);
 
-    if (!(sexpr = virDomainParseXMLDesc(domain->conn, xml, NULL, domain->conn->xendConfigVersion))) {
+    priv = (xenUnifiedPrivatePtr) domain->conn->privateData;
+
+    if (!(sexpr = virDomainParseXMLDesc(domain->conn, xml, NULL, priv->xendConfigVersion))) {
         free(xml);
         return (-1);
     }
@@ -1714,6 +1719,7 @@
     xmlChar *prop = NULL;
     virConfPtr conf = NULL;
     int hvm = 0, i;
+    xenUnifiedPrivatePtr priv;
 
     doc = xmlReadDoc((const xmlChar *) xml, "domain.xml", NULL,
                      XML_PARSE_NOENT | XML_PARSE_NONET |
@@ -1778,6 +1784,8 @@
         hvm = 1;
     xmlXPathFreeObject(obj);
 
+    priv = (xenUnifiedPrivatePtr) conn->privateData;
+
     if (hvm) {
         const char *boot = "c";
         if (xenXMConfigSetString(conf, "builder", "hvm") < 0)
@@ -1813,7 +1821,7 @@
                                        "cannot set the apic parameter") < 0)
             goto error;
 
-        if (conn->xendConfigVersion == 1) {
+        if (priv->xendConfigVersion == 1) {
             if (xenXMConfigSetStringFromXPath(conn, conf, ctxt, "cdrom", "string(/domain/devices/disk[@device='cdrom']/source/@file)", 1,
                                               "cannot set the cdrom parameter") < 0)
                 goto error;
@@ -1854,7 +1862,7 @@
 
     }
 
-    if (hvm || conn->xendConfigVersion < 3) {
+    if (hvm || priv->xendConfigVersion < 3) {
         if (xenXMConfigSetIntFromXPath(conn, conf, ctxt, "sdl", "string(count(/domain/devices/graphics[@type='sdl']))", 0, 0,
                                        "cannot set the sdl parameter") < 0)
             goto error;
@@ -1977,7 +1985,7 @@
         for (i = obj->nodesetval->nodeNr -1 ; i >= 0 ; i--) {
             virConfValuePtr thisDisk;
             char *disk = NULL;
-            if (xenXMParseXMLDisk(obj->nodesetval->nodeTab[i], hvm, conn->xendConfigVersion, &disk) < 0)
+            if (xenXMParseXMLDisk(obj->nodesetval->nodeTab[i], hvm, priv->xendConfigVersion, &disk) < 0)
                 goto error;
             if (disk) {
                 if (!(thisDisk = malloc(sizeof(virConfValue)))) {
Index: src/xm_internal.h
===================================================================
RCS file: /data/cvs/libvirt/src/xm_internal.h,v
retrieving revision 1.3
diff -u -r1.3 xm_internal.h
--- src/xm_internal.h	6 Mar 2007 21:55:44 -0000	1.3
+++ src/xm_internal.h	4 Apr 2007 10:14:41 -0000
@@ -27,12 +27,15 @@
 
 #include "libvirt/libvirt.h"
 #include "conf.h"
+#include "internal.h"
 
 #ifdef __cplusplus
 extern "C" {
 #endif
 
-void xenXMRegister(void);
+extern virDriver xenXMDriver;
+int xenXMInit (void);
+
 int xenXMOpen(virConnectPtr conn, const char *name, int flags);
 int xenXMClose(virConnectPtr conn);
 const char *xenXMGetType(virConnectPtr conn);
